-- Parts of code "borrowed" from No Interact by Rhyono

local LongPressCtrlToInteract =
 {
   Name = "LongPressCtrlToInteract",
   Author = "|c3CB371@Masteroshi430|r",
   Version = "2024.04.20",
   Defaults = 
   {
	 setKey = "CTRL",
	 noSeats = false,
	 noEmpties = false,
	 noKnownBooks = false,
	 noInsects = false,
	 companionRecall = false,
	 noInsectsWithMirri = false,
	 noCookingFires = false,
	 secondSpam = 0,
   },
   charDefaults = 
   {
	 PreferedCompanionCollectibleID = nil,
   }	 
 }

local function OnAddOnLoaded(event, addonName)
	if addonName == LongPressCtrlToInteract.Name then 
			-- Load the saved variables
    LongPressCtrlToInteract.vars = ZO_SavedVars:NewAccountWide("LongPressCtrlToInteractSavedVars", 2, nil, LongPressCtrlToInteract.Defaults)
	LongPressCtrlToInteract.CharSavedVars = ZO_SavedVars:NewCharacterIdSettings("LongPressCtrlToInteractSavedVars", 5, nil, LongPressCtrlToInteract.charDefaults)
	LongPressCtrlToInteract:Initialize()
    LongPressCtrlToInteract.CreateConfiguration()
	
	EVENT_MANAGER:UnregisterForEvent(LongPressCtrlToInteract.Name, EVENT_ADD_ON_LOADED)
	end
end



--Modified reticle hook from No, Thank You! 
local function HookReticleTake()
    LongPressCtrlToInteract.followerName = LongPressCtrlToInteract.followerName or "Norbert"
	local function DisableReticleTake_Hook(interactionPossible)
		if interactionPossible then
			local action,text,blocked,isOwned,addinfo,contextInfo,contextLink,isCriminalInteract = GetGameCameraInteractableActionInfo()


			-- do not display reticle text for empty containers KEEP FIRST
			if LongPressCtrlToInteract.vars.noEmpties and blocked and addinfo == ADDITIONAL_INTERACT_INFO_EMPTY then return true end 
			
			if text ~= '' and text ~= nil then
			   -- alert about Mirri 1 Isobel before entering Dark Brotherhood Sanctuary
			   if (IsCollectibleActive(9353) or IsCollectibleActive(9912)) and text == GetMapNameById(1063) and GetTimeStamp() > LongPressCtrlToInteract.vars.secondSpam + 6 then 
				  local msg = CENTER_SCREEN_ANNOUNCE:CreateMessageParams(CSA_CATEGORY_LARGE_TEXT, nil)
	              msg:SetText(zo_strformat(GetString(LPCI_DARK1), GetUnitName("companion")), GetString(LPCI_DARK2)) 
	              msg:SetCSAType(CENTER_SCREEN_ANNOUNCE_TYPE_ACTIVITY_COMPLETE)
	              msg:MarkSuppressIconFrame()
				  msg:SetIconData("esoui/art/icons/mapkey/mapkey_darkbrotherhood.dds", nil)
				  msg:MarkQueueImmediately()
				  msg:SetSound(SOUNDS.DAEDRIC_ARTIFACT_SPAWNED)
				  CENTER_SCREEN_ANNOUNCE:DisplayMessage(msg)
				  LongPressCtrlToInteract.vars.secondSpam = GetTimeStamp()
				  return true
				elseif (IsCollectibleActive(9353) or IsCollectibleActive(9912)) and text == GetMapNameById(1063) then  
				  return true
				end
				
			   -- alert about Isobel before entering an outlaw's refuge 
			   if IsCollectibleActive(9912) and string.find(text, GetString(SI_MONSTERSOCIALCLASS28)) and action == GetString(SI_GAMECAMERAACTIONTYPE13) and GetTimeStamp() > LongPressCtrlToInteract.vars.secondSpam + 6 then 
				  local msg = CENTER_SCREEN_ANNOUNCE:CreateMessageParams(CSA_CATEGORY_LARGE_TEXT, nil)
	              msg:SetText(zo_strformat(GetString(LPCI_OUTLAW1), GetUnitName("companion")), GetString(LPCI_OUTLAW2)) 
	              msg:SetCSAType(CENTER_SCREEN_ANNOUNCE_TYPE_ACTIVITY_COMPLETE)
	              msg:MarkSuppressIconFrame()
				  msg:SetIconData("esoui/art/icons/mapkey/mapkey_fence.dds", nil)
				  msg:MarkQueueImmediately()
				  msg:SetSound(SOUNDS.DAEDRIC_ARTIFACT_SPAWNED)
				  CENTER_SCREEN_ANNOUNCE:DisplayMessage(msg)
				  LongPressCtrlToInteract.vars.secondSpam = GetTimeStamp()
				  return true
				elseif IsCollectibleActive(9912) and action == GetString(SI_GAMECAMERAACTIONTYPE13) and string.find(text, GetString(SI_MONSTERSOCIALCLASS28)) then  
				  return true
				end
				
			
				-- don't display reticle text for seats
				if LongPressCtrlToInteract.vars.noSeats and text == GetString(LPCI_SEAT) then return true end
				
				-- don't display reticle text for Cooking Fire not in town
				if LongPressCtrlToInteract.vars.noCookingFires and GetMapType() ~= MAPTYPE_SUBZONE and text == GetString(LPCI_COOKING_FIRE) then return true end
				
				
               -- don't display reticle text for insects Mirri does't want you to kill
                if LongPressCtrlToInteract.isNoInsectsWithMirri() and (text == GetString(LPCI_INSECT_BUTTERFLY) or text == GetString(LPCI_INSECT_TORCHBUG)) then
				    return true
                end				
				
				-- don't display reticle text for all insects
				-- if LongPressCtrlToInteract.vars.noInsects and (text == GetString(LPCI_INSECT_BUTTERFLY) or text == GetString(LPCI_INSECT_TORCHBUG) or (text == GetString(LPCI_INSECT_WASP) and action == GetString(SI_GAMECAMERAACTIONTYPE7)) 
				   -- or text == GetString(LPCI_INSECT_FLESHFLIES) or text == GetString(LPCI_INSECT_DRAGONFLY) or text == GetString(LPCI_INSECT_NETCHCALF)	or text == GetString(LPCI_INSECT_FETCHERFLY) or text == GetString(LPCI_INSECT_DOVAH)
                   -- or text == GetString(LPCI_INSECT_WINTER)	or text == GetString(LPCI_INSECT_MOONS) or text == GetString(LPCI_INSECT_SWAMP_JELLY) or text == GetString(LPCI_INSECT_BLACKREACH_JELLY) or text == GetString(LPCI_INSECT_MOON_JELLY))  then
				   -- return true
				-- end
			end	
			
			if action == GetString(SI_GAMECAMERAACTIONTYPE3) or action == GetString(SI_GAMECAMERAACTIONTYPE4) or action == GetString(SI_GAMECAMERAACTIONTYPE8) or action == GetString(SI_GAMECAMERAACTIONTYPE9)
			   or action == GetString(SI_GAMECAMERAACTIONTYPE11) or action == GetString(SI_GAMECAMERAACTIONTYPE12) or action == GetString(SI_GAMECAMERAACTIONTYPE16) or action == GetString(SI_GAMECAMERAACTIONTYPE17)
			   or action == GetString(SI_GAMECAMERAACTIONTYPE18) or action == GetString(SI_GAMECAMERAACTIONTYPE19) or action == GetString(SI_GAMECAMERAACTIONTYPE20) or action == GetString(SI_GAMECAMERAACTIONTYPE21)
			   or action == GetString(SI_GAMECAMERAACTIONTYPE23) or action == GetString(SI_GAMECAMERAACTIONTYPE24) or action == GetString(SI_GAMECAMERAACTIONTYPE25) or action == GetString(SI_GAMECAMERAACTIONTYPE26) 
			   or action == GetString(SI_GAMECAMERAACTIONTYPE27) or (action == GetString(SI_GAMECAMERAACTIONTYPE1) and IsGameCameraInteractableUnitMonster()) or action == GetString(SI_GAMECAMERAACTIONTYPE5) 
			   or action == GetString(SI_GAMECAMERAACTIONTYPE7) or action == GetString(SI_GAMECAMERAACTIONTYPE13) then 
			   return false -- performance Filtering: Regular behavior with -- harvest -- disarm -- destroy -- repair -- unlock -- fish -- Reel In -- Pack Up -- steal -- Steal From -- pickpocket -- trespass -- hide -- preview -- exit home -- excavate -- search (enemy corpses only)  -- use -- take -- open
			end

			if text ~= '' and text ~= nil then
			    -- do not display reticle text for companion without the Ctrl key presssed
			    if text == GetUnitName("companion") and not LongPressCtrlToInteract.isKeyDown() then return true end
			    
				-- do not display reticle text for follower without the Ctrl key pressed
				if  text == LongPressCtrlToInteract.followerName and not LongPressCtrlToInteract.isKeyDown() then return true end
				
				-- do not display reticle text for known books  if ACTIONS: -- Search -- Read --- Examine ---
				--if LongPressCtrlToInteract.vars.noKnownBooks and (action == GetString(SI_GAMECAMERAACTIONTYPE1) or action == GetString(SI_GAMECAMERAACTIONTYPE15) or action == GetString(SI_GAMECAMERAACTIONTYPE6)) and LongPressCtrlToInteract.isKnownBook(text) then return true end
				--to test : "Inspect", -- SI_GAMECAMERAACTIONTYPE10
				
			    -- should work for group companions 
				local maxGroupSize = GROUP_SIZE_MAX or MAX_GROUP_SIZE_THRESHOLD
			    for i=1, maxGroupSize do
						if text == GetUnitName("group"..i.."companion") and not LongPressCtrlToInteract.isKeyDown() then
							return true
						end
				end
				
			end	
		end
	    return false
	end	
	ZO_PreHook(RETICLE, "TryHandlingInteraction", DisableReticleTake_Hook)
end

-- the settings menu
function LongPressCtrlToInteract.CreateConfiguration()
	local LAM = LibAddonMenu2
	local panelData = 
	{
		type = "panel",
		name = LongPressCtrlToInteract.Name,
		author = LongPressCtrlToInteract.Author,
		version = LongPressCtrlToInteract.Version,
		registerForDefaults = true,
		registerForRefresh = true,
	}
	LAM:RegisterAddonPanel(LongPressCtrlToInteract.Name.."Config", panelData)
	
    local optionsData = {}
    optionsData[#optionsData + 1] = 
	{
	  type = "dropdown",
	  name = GetString(LPCI_LONG),
	  tooltip = GetString(LPCI_LONG_TOOLTIP_1)..ZO_Keybindings_GetBindingStringFromAction("GAME_CAMERA_INTERACT", KEYBIND_TEXT_OPTIONS_FULL_NAME, KEYBIND_TEXTURE_OPTIONS_NONE, 1)..GetString(LPCI_LONG_TOOLTIP_2),
	  choices = {"CTRL", "SHIFT", "ALT", "CMD"},
	  getFunc = function()  return LongPressCtrlToInteract.vars.setKey end, 
	  setFunc = function(NewVal) LongPressCtrlToInteract.vars.setKey = NewVal end,
	  width = "half",
	} 
    optionsData[#optionsData + 1] = 
	{
	  type = "checkbox",
	  name = GetString(LPCI_NO_SEATS),
	  tooltip = GetString(LPCI_NO_SEATS_TOOLTIP),
	  getFunc = function() return LongPressCtrlToInteract.vars.noSeats end,
      setFunc = function(NewVal) LongPressCtrlToInteract.vars.noSeats = NewVal end,
      width = "half",	--or "full" (optional)
	} 
    optionsData[#optionsData + 1] = 
	{
	  type = "checkbox",
	  name =  GetString(LPCI_NO_EMPTY),
	  tooltip = GetString(LPCI_NO_EMPTY_TOOLTIP),
	  getFunc = function() return LongPressCtrlToInteract.vars.noEmpties end,
      setFunc = function(NewVal) LongPressCtrlToInteract.vars.noEmpties = NewVal end,
      width = "half",	--or "full" (optional)
	} 	
    -- optionsData[#optionsData + 1] = 
	-- {
	  -- type = "checkbox",
	  -- name = GetString(LPCI_NO_KNOWN_BOOKS),
	  -- tooltip = GetString(LPCI_NO_KNOWN_BOOKS_TOOLTIP),
	  -- getFunc = function() return LongPressCtrlToInteract.vars.noKnownBooks end,
      -- setFunc = function(NewVal) LongPressCtrlToInteract.vars.noKnownBooks = NewVal end,
      -- width = "half",	--or "full" (optional)
	-- }
    -- optionsData[#optionsData + 1] = 
	-- {
	  -- type = "checkbox",
	  -- name = GetString(LPCI_NO_INSECTS),
	  -- tooltip = GetString(LPCI_NO_INSECTS_TOOLTIP),
	  -- getFunc = function() return LongPressCtrlToInteract.vars.noInsects end,
      -- setFunc = function(NewVal) LongPressCtrlToInteract.vars.noInsects = NewVal end,
      -- width = "half",	--or "full" (optional)
	-- }
    optionsData[#optionsData + 1] = 
	{
	  type = "checkbox",
	  name = GetString(LPCI_COMPANION_RECALL),
	  tooltip = GetString(LPCI_COMPANION_RECALL_TOOLTIP),
	  getFunc = function() return LongPressCtrlToInteract.vars.companionRecall end,
      setFunc = function(NewVal) LongPressCtrlToInteract.vars.companionRecall = NewVal end,
      width = "half",	--or "full" (optional)
	}
    optionsData[#optionsData + 1] = 
	{
	  type = "checkbox",
	  name = GetString(LPCI_NO_INSECTS_WITH_MIRRI),
	  tooltip = GetString(LPCI_NO_INSECTS_WITH_MIRRI_TOOLTIP),
	  getFunc = function() return LongPressCtrlToInteract.vars.noInsectsWithMirri end,
      setFunc = function(NewVal) LongPressCtrlToInteract.vars.noInsectsWithMirri = NewVal end,
      width = "half",	--or "full" (optional)
	}
    optionsData[#optionsData + 1] = 
	{
	  type = "checkbox",
	  name = GetString(LPCI_NO_COOKING_FIRES),
	  tooltip = GetString(LPCI_NO_COOKING_FIRES_TOOLTIP),
	  getFunc = function() return LongPressCtrlToInteract.vars.noCookingFires end,
      setFunc = function(NewVal) LongPressCtrlToInteract.vars.noCookingFires = NewVal end,
      width = "half",	--or "full" (optional)
	}
	LAM:RegisterOptionControls(LongPressCtrlToInteract.Name.."Config", optionsData)
end

-- is the key down?
function LongPressCtrlToInteract.isKeyDown()
    local key = LongPressCtrlToInteract.vars.setKey
	if  string.upper(key) == "CTRL" then return IsControlKeyDown()
	elseif  string.upper(key) == "SHIFT" then return IsShiftKeyDown()
	elseif  string.upper(key) == "ALT" then return IsAltKeyDown()
	elseif  string.upper(key) == "CMD" then return IsCommandKeyDown()
	end
end

-- is the future interaction a known book?
-- function LongPressCtrlToInteract.isKnownBook(thisTitle) 
	-- for index = 1, #LongPressCtrlToInteract.knownBookTitles do
	     -- local bookTitle = LongPressCtrlToInteract.knownBookTitles[index]
		 -- if thisTitle == bookTitle then
			-- return true
		-- else 
			-- local toSplit = LongPressCtrlToInteract.mysplit(thisTitle, ":")
			-- if toSplit[2] then
			   -- toSplit[2] = toSplit[2]:sub(2)
			   -- if toSplit[2] == bookTitle then return true end	-- workaround for "Note: A Way Out" type titles
			-- end	
		-- end
	-- end
    -- return false
-- end	

-- populate list of known book titles at load 
-- function LongPressCtrlToInteract.PopulateKnownLorebooksAtStart()
    -- LongPressCtrlToInteract.knownBookTitles = {}
    -- for categoryIndex = 1, GetNumLoreCategories() do
        -- local categoryName, numCollections = GetLoreCategoryInfo(categoryIndex)
        -- for collectionIndex = 1, numCollections do
            -- local collectionName, description, numKnownBooks, totalBooks, hidden = GetLoreCollectionInfo(categoryIndex, collectionIndex)
            -- if not hidden then
                -- for bookIndex = 1, totalBooks do
                    -- local title, icon, known = GetLoreBookInfo(categoryIndex, collectionIndex, bookIndex)
                    -- if  known then
                       -- table.insert(LongPressCtrlToInteract.knownBookTitles, title)
                    -- end
                -- end
            -- end
        -- end
    -- end
-- end

-- populate list of known book titles at book learned 
-- function LongPressCtrlToInteract.LorebookLearned(categoryIndex, collectionIndex,  bookIndex)
   -- local title, icon, known = GetLoreBookInfo(categoryIndex, collectionIndex, bookIndex)
   -- table.insert(LongPressCtrlToInteract.knownBookTitles, title)
-- end 

-- string splitter
function LongPressCtrlToInteract.mysplit(inputstr, sep)
        if sep == nil then
                sep = "%s"
        end
        local t={}
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                table.insert(t, str)
        end
        return t
end

-- Call last companion after combat
function LongPressCtrlToInteract.CallPreferedAssistant()
    if not LongPressCtrlToInteract.vars.companionRecall then return end
	
	if HasActiveCompanion() == true then 
	   local activeCompanionCollectibleID = GetActiveCollectibleByType(COLLECTIBLE_CATEGORY_TYPE_COMPANION, GAMEPLAY_ACTOR_CATEGORY_COMPANION)
	   if IsCollectibleActive(activeCompanionCollectibleID) then 
		      LongPressCtrlToInteract.CharSavedVars.PreferedCompanionCollectibleID = activeCompanionCollectibleID
	      return
	   end
	end

	if IsUnitInCombat("player") or GetGroupSize() > 1 then return end

	if LongPressCtrlToInteract.CharSavedVars.PreferedCompanionCollectibleID and HasActiveCompanion() == false and not IsInAvAZone() and not IsCollectibleBlocked(LongPressCtrlToInteract.CharSavedVars.PreferedCompanionCollectibleID,GAMEPLAY_ACTOR_CATEGORY_COMPANION) then zo_callLater(function()  UseCollectible(LongPressCtrlToInteract.CharSavedVars.PreferedCompanionCollectibleID) end, 5000)  end
end

-- do we stop interaction with insects when Mirri is active
function LongPressCtrlToInteract.isNoInsectsWithMirri()
   if LongPressCtrlToInteract.vars.noInsectsWithMirri == false then return false end
   
   if HasActiveCompanion() == true then 
	   if IsCollectibleActive(9353) then return true end -- MIRRI ELENDIS
   end
   return false
end

-- init
function LongPressCtrlToInteract.Initialize()
	EVENT_MANAGER:UnregisterForEvent(LongPressCtrlToInteract.Name, EVENT_ADD_ON_LOADED)
	EVENT_MANAGER:RegisterForEvent(LongPressCtrlToInteract.Name, EVENT_CHATTER_BEGIN,LongPressCtrlToInteract.GetThatFollowerName)
	--EVENT_MANAGER:RegisterForEvent(LongPressCtrlToInteract.Name, EVENT_LORE_BOOK_LEARNED,LongPressCtrlToInteract.LorebookLearned) 

	-- combat state
	EVENT_MANAGER:RegisterForEvent(LongPressCtrlToInteract.Name, EVENT_PLAYER_COMBAT_STATE, LongPressCtrlToInteract.CallPreferedAssistant)
	
	--LongPressCtrlToInteract.PopulateKnownLorebooksAtStart()
	HookReticleTake()
end

--- Get follower name from 1st interaction
function LongPressCtrlToInteract.GetThatFollowerName()
    if IsInteractingWithMyAssistant() or IsUnitFriendlyFollower("interact") == false or GetUnitName("interact") == nil or GetUnitName("interact") == "" or GetUnitName("interact") == GetUnitName("companion")then return end
    LongPressCtrlToInteract.followerName = GetUnitName("interact") 
end

--Stops interaction
local WHEEL_MANAGER = INTERACTIVE_WHEEL_MANAGER
local orgInteract = WHEEL_MANAGER.StartInteraction
    WHEEL_MANAGER.StartInteraction = function(...)
	local action,text,blocked,isOwned,addinfo,contextInfo,contextLink,isCriminalInteract = GetGameCameraInteractableActionInfo()
	
	local keyString = ZO_Keybindings_GetBindingStringFromAction("GAME_CAMERA_INTERACT", KEYBIND_TEXT_OPTIONS_FULL_NAME, KEYBIND_TEXTURE_OPTIONS_NONE, 1)

	-- -- 500ms cooldown to avoid double tap/click
	if LongPressCtrlToInteract.LastStartInterraction and GetFrameTimeMilliseconds() < LongPressCtrlToInteract.LastStartInterraction + 500 then
	   return true
	end
	LongPressCtrlToInteract.LastStartInterraction = GetFrameTimeMilliseconds()
	
	-- exclude nil or blank text
	if text == nil or text == '' then return orgInteract(...) end   
    
	local key = LongPressCtrlToInteract.vars.setKey
	
    -- do not interact with empty containers KEEP FIRST
	if LongPressCtrlToInteract.vars.noEmpties and blocked and addinfo == ADDITIONAL_INTERACT_INFO_EMPTY then return true end 
	
	-- Mirri and Isobel : disallow entering Dark Brotherhood Sanctuary 
   if (IsCollectibleActive(9353) or IsCollectibleActive(9912)) and text == GetMapNameById(1063) then
       return true
   end

	-- Isobel : disallow entering an outlaw's refuge 
   if IsCollectibleActive(9912) and action == GetString(SI_GAMECAMERAACTIONTYPE13) and string.find(text, GetString(SI_MONSTERSOCIALCLASS28)) then
       return true
   end     

   
	
	-- do not interact with seats
	if LongPressCtrlToInteract.vars.noSeats and text == GetString(LPCI_SEAT) then return true end
	
	-- do not interact with Cooking Fire not in town 
	if LongPressCtrlToInteract.vars.noCookingFires and GetMapType() ~= MAPTYPE_SUBZONE and text == GetString(LPCI_COOKING_FIRE) then return true end
		
	   -- do not interact with insects Mirri does't want you to kill
		if LongPressCtrlToInteract.isNoInsectsWithMirri() and (text == GetString(LPCI_INSECT_BUTTERFLY) or text == GetString(LPCI_INSECT_TORCHBUG)) then
			return true
		end				
		
		-- do not interact with insects
		-- if LongPressCtrlToInteract.vars.noInsects and (text == GetString(LPCI_INSECT_BUTTERFLY) or text == GetString(LPCI_INSECT_TORCHBUG) or (text == GetString(LPCI_INSECT_WASP) and action == GetString(SI_GAMECAMERAACTIONTYPE7)) 
		   -- or text == GetString(LPCI_INSECT_FLESHFLIES) or text == GetString(LPCI_INSECT_DRAGONFLY) or text == GetString(LPCI_INSECT_NETCHCALF)	or text == GetString(LPCI_INSECT_FETCHERFLY) or text == GetString(LPCI_INSECT_DOVAH)
		   -- or text == GetString(LPCI_INSECT_WINTER)	or text == GetString(LPCI_INSECT_MOONS) or text == GetString(LPCI_INSECT_SWAMP_JELLY) or text == GetString(LPCI_INSECT_BLACKREACH_JELLY) or text == GetString(LPCI_INSECT_MOON_JELLY))  then
		   -- return true
		-- end
	
	if action == GetString(SI_GAMECAMERAACTIONTYPE3) or action == GetString(SI_GAMECAMERAACTIONTYPE4) or action == GetString(SI_GAMECAMERAACTIONTYPE8) or action == GetString(SI_GAMECAMERAACTIONTYPE9)
	   or action == GetString(SI_GAMECAMERAACTIONTYPE11) or action == GetString(SI_GAMECAMERAACTIONTYPE12) or action == GetString(SI_GAMECAMERAACTIONTYPE16) or action == GetString(SI_GAMECAMERAACTIONTYPE17)
	   or action == GetString(SI_GAMECAMERAACTIONTYPE18) or action == GetString(SI_GAMECAMERAACTIONTYPE19) or action == GetString(SI_GAMECAMERAACTIONTYPE20) or action == GetString(SI_GAMECAMERAACTIONTYPE21)
	   or action == GetString(SI_GAMECAMERAACTIONTYPE23) or action == GetString(SI_GAMECAMERAACTIONTYPE24) or action == GetString(SI_GAMECAMERAACTIONTYPE25) or action == GetString(SI_GAMECAMERAACTIONTYPE26) 
	   or action == GetString(SI_GAMECAMERAACTIONTYPE27) or (action == GetString(SI_GAMECAMERAACTIONTYPE1) and IsGameCameraInteractableUnitMonster()) or action == GetString(SI_GAMECAMERAACTIONTYPE5) 
	   or action == GetString(SI_GAMECAMERAACTIONTYPE7) or action == GetString(SI_GAMECAMERAACTIONTYPE13) then 
	   return orgInteract(...)  -- performance Filtering: Regular behavior with -- harvest -- disarm -- destroy -- repair -- unlock -- fish -- Reel In -- Pack Up -- steal -- Steal From -- pickpocket -- trespass -- hide -- preview -- exit home -- excavate -- search (enemy corpses only)  -- use -- take -- open
	end	
	
	 -- chat message if you try to interact with companion without the Ctrl key
	 if text == GetUnitName("companion") and not LongPressCtrlToInteract.isKeyDown() then 
		 CHAT_SYSTEM:AddMessage("|c666666"..GetString(LPCI_PRESS).."|r |cC3C09C"..string.upper(key).."+"..keyString.."|r |c666666"..GetString(LPCI_TO_INTERACT_WITH).."|r|c9DFE00"..zo_iconTextFormatNoSpace("esoui/art/compass/activecompanion.dds",20,20,"")..text..".|r")
		 return true
	 end
	
	 -- chat message if you try to interact with follower without the Ctrl key 
	 if text == LongPressCtrlToInteract.followerName and not LongPressCtrlToInteract.isKeyDown() then 
		 CHAT_SYSTEM:AddMessage("|c666666"..GetString(LPCI_PRESS).."|r |cC3C09C"..string.upper(key).."+"..keyString.."|r |c666666"..GetString(LPCI_TO_INTERACT_WITH).."|r|c9DFE00"..zo_iconTextFormatNoSpace("LongPressCtrlToInteract/art/icons/follower_32.dds",16,16,"")..text..".|r") 
		 return true
	 end
	 
	-- should work for group companions
	local maxGroupSize = GROUP_SIZE_MAX or MAX_GROUP_SIZE_THRESHOLD
	for i=1, maxGroupSize do 
	    if text == GetUnitName("group"..i.."companion") and not LongPressCtrlToInteract.isKeyDown() then   
			CHAT_SYSTEM:AddMessage("|c666666"..GetString(LPCI_PRESS).."|r |cC3C09C"..string.upper(key).."+"..keyString.."|r |c666666"..GetString(LPCI_TO_INTERACT_WITH).."|r|c9DFE00"..zo_iconTextFormatNoSpace("esoui/art/compass/activecompanion.dds",20,20,"")..text..".|r")
		    return true
        end
	end
	
		-- do not interact with known books  if ACTIONS: -- Search -- Read --- Examine ---
	--if LongPressCtrlToInteract.vars.noKnownBooks and (action == GetString(SI_GAMECAMERAACTIONTYPE1) or action == GetString(SI_GAMECAMERAACTIONTYPE15) or action == GetString(SI_GAMECAMERAACTIONTYPE6)) and LongPressCtrlToInteract.isKnownBook(text) then return true end
	
	return orgInteract(...)
end



EVENT_MANAGER:RegisterForEvent(LongPressCtrlToInteract.Name, EVENT_ADD_ON_LOADED, OnAddOnLoaded)

